function love.load()
	love.graphics.setCaption("Falling Snow")
	love.graphics.setMode( 400, 320, false, false, 0)
	init()
end


function love.update(dt)
	changestate()
	_counter = _counter + dt
	if gamestate.game == true then
		timeout(dt)
		enemymove(dt)
		playermove(dt)
		if _counter >= 1 then
		_enemy()
		_counter = 0
		end
	end
end

function love.draw()
	if gamestate.over == true then
		love.graphics.print(" Press Enter to try Again!", 10, 160)
	end
	if gamestate.pause == true then
		love.graphics.print(" Press Enter to continue!", 10 , 160)
	end
	if gamestate.menu == true then
		love.graphics.print(" Catch the Snow!", 10, 148)
		love.graphics.print(" Press Enter to start the Game!", 10, 160 )
	end
	if gamestate.game == true then
		-- Drawing the Player
		love.graphics.rectangle("fill", player.x, player.y, player.width, player.height)
		-- Drawing the Score/FPS/Time
		love.graphics.print("Time: " .. time, 10, 10)
		love.graphics.print("Score: " .. score, 10, 30)
		-- Drawing Enemys
		love.graphics.setPoint(3, "smooth")
			for i, v in ipairs(enemy) do
				love.graphics.point(v.x, v.y)
			end
	end
end



function playermove(dt)
	if love.keyboard.isDown("left") then
		test = player.x - dt * player.speed
			if test > 0 then		
				player.x = player.x - dt * player.speed
			else
				return
			end
		
	elseif love.keyboard.isDown("right") then
		test = player.x + dt * player.speed
			if test < 400 then
				player.x = player.x + dt * player.speed
			else
				return
			end
	end
	--[[
	if love.keyboard.isDown("up") then
		player.y = player.y - dt * player.speed
	elseif love.keyboard.isDown("down") then
		player.y = player.y + dt * player.speed
	end
	]]--
end

function _enemy()
	if enemycount <= 6 then
	local en = {}
	en.speed = math.random(70,100)
	en.x = math.random(0,390)
	en.y = 0
	table.insert(enemy, en)
	enemycount = enemycount + 1
	else
	return
	end
end
function enemymove(dt)
	for i,v in ipairs(enemy) do
		v.y = v.y + dt * v.speed
			if v.y >= 320 then
				table.remove(enemy, i)
				enemycount = enemycount - 1
			elseif v.x >= (player.x-5) and v.x <= (player.x+5) and v.y >= (player.y - 5) and v.y <= (player.y + 5) then
				table.remove(enemy, i)
				enemycount = enemycount - 1
				score = score + 1
			end
	end
end		
function init()
	player = {}
	player.x = 10
	player.y = 308
	player.speed = 150
	player.height = 10
	player.width = 10
	gamestate = {}
	gamestate.menu = true
	gamestate.game = false
	gamestate.pause = false
	gamestate.over = false
	time = 20
	score = 0
	enemy = {}
	enemycount = 0
	_counter = 0
end

function changestate()
	if gamestate.menu == true and love.keyboard.isDown("return") then
		gamestate.menu = false
		gamestate.game = true
	end
	if gamestate.game == true and love.keyboard.isDown("p") then
		gamestate.game = false
		gamestate.pause = true
	end
	if gamestate.pause == true and love.keyboard.isDown("return") then
		gamestate.pause = false
		gamestate.game = true
	end
	if gamestate.over == true and love.keyboard.isDown("return") then
		newGame()
		gamestate.over = false 
		gamestate.game = true
	end
end
function timeout(dt)
	time = time - dt
	if time <= 0 then
	gamestate.game = false 
	gamestate.over = true
	end
end

function newGame()
	init()
end
	
	
